package Physics;
//import com.jogamp.opengl.GL;
//import com.jogamp.opengl.GLAutoDrawable;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;

/**
* The OpenGL-window
*/
class ParticlesGLView extends BaseGLView
{ 
	private static final long serialVersionUID = 1L;
	static ParticlesSimulation _sim;

	public ParticlesGLView( ParticlesSimulation aSimulation )
	{
		_sim = aSimulation;
		_PositionZ = -50.0; //-70
	}

	// generate scene
	public void display(GLAutoDrawable gLDrawable)
	{
		gl = gLDrawable.getGL();
		//glu = new GLU();
		gl.glClearColor( 0.3f, 0.3f, 0.3f, 0f );
		gl.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
		gl.glDisable( GL.GL_LIGHTING ); //lines do not have a lightning-direction
	    gl.glDisable( GL.GL_DEPTH_TEST ); //sort the faces from back to front
		gl.glDisable( GL.GL_CULL_FACE ); //select only winding-correct

		GLPespective(); //TODO? call here? Needed for zoom-Keys
		
		gl.glPushMatrix(); //push parameter for the next loop
		gl.glTranslated(_PositionX, _PositionY, _PositionZ);
		gl.glRotated( _tetha, 1.0,  0.0,  0.0 );
		gl.glRotated( _phi, 0.0,  1.0,  0.0 );

		DrawGrid();

		gl.glPopMatrix(); //rotate back for rotation independent working tools like ruler or selectable points
		gl.glFlush();
		//swapBuffers();
	}

	/**
	 * draw the grid
	 */
	void DrawGrid()
	{
		gl.glTranslated( 0.0, -_sim.cnGridSizeY, 0 );

		drawSquare( gl, -_sim.cnGridSizeX, 0,  _sim.cnGridSizeX, _sim.cnGridSizeY*2 );		

		for( int n=0; n<_sim.ParticleSize; n++ )
		{
			double dSize = 0.5;
			gl.glBegin( GL.GL_LINES );
			gl.glVertex3d( _sim.aParticle[n].getX()-dSize,  _sim.aParticle[n].getY(), _sim.aParticle[n].getZ() );
			gl.glVertex3d( _sim.aParticle[n].getX()+dSize,  _sim.aParticle[n].getY(), _sim.aParticle[n].getZ() );
			gl.glVertex3d( _sim.aParticle[n].getX(),  _sim.aParticle[n].getY()-dSize, _sim.aParticle[n].getZ() );
			gl.glVertex3d( _sim.aParticle[n].getX(),  _sim.aParticle[n].getY()+dSize, _sim.aParticle[n].getZ() );
			gl.glEnd();
		}

		//TODO later DrawCornerCoodinateSystem();
	}

	@Override
	public void drawPickingObjects(GL gl) { } //not used yet.
//	@Override public void dispose(GLAutoDrawable arg0) { }
}
