package Physics;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

//import com.jogamp.opengl.util.FPSAnimator; 
import com.sun.opengl.util.FPSAnimator;

/**
 * Simulates a falling drop (finite particles algorithm). 
 */
public class ParticlesMain extends JPanel
{
	private static final long serialVersionUID = 1L;

	static ParticlesSimulation _sim = null;
	static FPSAnimator animator = null;
	
	JSplitPane splitPane;

	static ParticlesGLView glWindow;
	
	JButton buttonZoomIn;
	JButton buttonZoomOut;
	JButton buttonInit;
	JButton buttonRun;
	JButton buttonStep;
	JSeparator separator;
	
     
    public ParticlesMain()
    {
        super( new BorderLayout() );
 
        splitPane = new JSplitPane( 1 ); //vertical split
        
		_sim = new ParticlesSimulation();
        glWindow = new ParticlesGLView( _sim );
        		
        //Create the check boxes.
        buttonZoomIn = new JButton("Zoom in");
        buttonZoomIn.setMnemonic(KeyEvent.VK_PLUS);
        buttonZoomOut = new JButton("Zoom out");
        buttonZoomOut.setMnemonic(KeyEvent.VK_MINUS);

        buttonInit = new JButton("Init");
        buttonInit.setMnemonic(KeyEvent.VK_I);
        buttonRun = new JButton("Run");
        buttonRun.setMnemonic(KeyEvent.VK_R);
        buttonStep = new JButton("Step");
        buttonStep.setMnemonic(KeyEvent.VK_S);
    	separator = new JSeparator();
                
        buttonZoomIn.addActionListener(
            	new ActionListener() {
                	public void actionPerformed(ActionEvent e) { glWindow._PositionZ -= 0.2*glWindow._PositionZ; }
                }
            );
        buttonZoomOut.addActionListener(
            	new ActionListener() {
                	public void actionPerformed(ActionEvent e) {glWindow._PositionZ += 0.2*glWindow._PositionZ; }
                }
            );
        buttonInit.addActionListener(
        	new ActionListener() {
            	public void actionPerformed(ActionEvent e) { _sim.Init(); }
            }
        );
        buttonRun.addActionListener(
           	new ActionListener() {
               	public void actionPerformed(ActionEvent e) { _sim.nRun=true; }
            }
        );
        buttonStep.addActionListener(
        	new ActionListener() {
               	public void actionPerformed(ActionEvent e) { _sim.nStep=true; }
            }
        );        

        this.add( splitPane );
        
        //Put the check boxes in a column in a panel
        JPanel checkPanel = new JPanel( new GridLayout(0,1) );
        
        splitPane.add( checkPanel );
        splitPane.add( glWindow );
        
        checkPanel.add(buttonZoomIn);
        checkPanel.add(buttonZoomOut);
        checkPanel.add(buttonInit);
        checkPanel.add(buttonRun);
        checkPanel.add(buttonStep);
        checkPanel.add(separator);
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("LavaDemo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
 
        //Create and set up the content pane.
        JComponent newContentPane = new ParticlesMain();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        glWindow.addGLEventListener(glWindow);

		animator = new FPSAnimator(glWindow, 10); //10 fps
		frame.addWindowListener(new WindowAdapter() {
			//@Override
			public void windowClosing(WindowEvent e) {
				animator.stop();
				System.exit(0);
			}
		});
        
        //Display the window.
        frame.pack();
		frame.setSize(1000, 800); 
        frame.setVisible(true);
        _sim.start();
		animator.start();
    }
 
    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(
        	new Runnable() {
        		public void run()
        			{ createAndShowGUI(); }
        	}
        );
    }
}
