package Physics;

//import com.jogamp.opengl.GL;
//import com.jogamp.opengl.GLAutoDrawable;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;

/**
* The OpenGL-window 
*/
class WaveGLView extends BaseGLView
{ 
	private static final long serialVersionUID = 1L;
	static WaveSimulation _sim;

	public WaveGLView( WaveSimulation aSimulation )
	{
		_sim = aSimulation;
//		super( aSimulation );
		_PositionZ = -50.0;
	}

	// generate scene
	public void display(GLAutoDrawable gLDrawable)
	{
		gl = gLDrawable.getGL();
		//glu = new GLU();
		gl.glClearColor( 0.3f, 0.3f, 0.3f, 0f );
		gl.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
		gl.glDisable( GL.GL_LIGHTING ); //lines do not have a lightning-direction
	    gl.glDisable( GL.GL_DEPTH_TEST ); //sort the faces from back to front
		gl.glDisable( GL.GL_CULL_FACE ); //select only winding-correct

		GLPespective(); //TODO? call here? Needed for zoom-Keys
		
		gl.glPushMatrix(); //push parameter for the next loop
		gl.glTranslated(_PositionX, _PositionY, _PositionZ);
		gl.glRotated( _tetha, 1.0,  0.0,  0.0 );
		gl.glRotated( _phi, 0.0,  1.0,  0.0 );

		DrawGrid();

		gl.glPopMatrix(); //rotate back for rotation independent working tools like ruler or selectable points
		gl.glFlush();
	}

	/**
	 * draw the grid
	 */
	void DrawGrid()
	{
		gl.glTranslated( -_sim.cnMidPos, -_sim.cnMidPos, -_sim.cnMidPos );

		drawCube( _sim.cnGridSize-1 );		

		//draw a point at every grid-knot
	/*	gl.glBegin(GL_POINTS);
		for( int z=1; z<cnGridSize-1; z++)
		  for( int y=1; y<cnGridSize-1; y++)
		    for( int x=1; x<cnGridSize-1; x++)
			{
//				if( (x+y+z)%2 ) continue; //only even points
				gl.glVertex3d(x, y, z ); //plot only odd coordinates
			}
		glEnd();*/

		double dDrawLengthFactor = 1.0;

		gl.glColor4d(0.8, 0.8, 0.8, 1.0); 
		gl.glBegin( GL.GL_LINES );
		for( int z=1; z<_sim.cnGridSize-1; z++) {
		  for( int y=1; y<_sim.cnGridSize-1; y++) {
		    for( int x=1; x<_sim.cnGridSize-1; x++) {
				if( _sim.paramCheckColor ) //use rainbow-colors?
				{
					gl.glColor4d( 0.5+0.5*_sim.aGridDataMove[z][y][x].getX()
								, 0.5+0.5*_sim.aGridDataMove[z][y][x].getY()
								, 0.5+0.5*_sim.aGridDataMove[z][y][x].getZ(), 1.0); //X
				}

				gl.glVertex3d(x, y, z );
				gl.glVertex3d( x+dDrawLengthFactor*_sim.aGridDataMove[z][y][x].getX()
					     	, y+dDrawLengthFactor*_sim.aGridDataMove[z][y][x].getY()
					     	, z+dDrawLengthFactor*_sim.aGridDataMove[z][y][x].getZ() );
			}
		  }
		}
		gl.glEnd();

		//TODO later DrawCornerCoodinateSystem();
	}

	@Override
	public void drawPickingObjects(GL gl) { } //not used yet.   
//	@Override public void dispose(GLAutoDrawable arg0) { }
}

